//-------------------------------------------------------------
// File: main.cpp
//
// Desc: n
//-------------------------------------------------------------
#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include <basetsd.h>
#include <math.h>
#include <stdio.h>
#include <d3dx9.h>
#include <dxerr9.h>
#include <tchar.h>
#include "DXUtil.h"
#include "D3DEnumeration.h"
#include "D3DSettings.h"
#include "D3DApp.h"
#include "D3DFont.h"
#include "D3DFile.h"
#include "D3DUtil.h"
#include "resource.h"
#include "main.h"

#define RENDERING_WIDTH		512
#define RENDERING_HEIGHT	512
#define MAP_WIDTH			128
#define MAP_HEIGHT			128

#define PASS_SCENE			0
#define PASS_REDUCTION		1
#define PASS_X				2
#define PASS_Y				3
#define PASS_FINAL			4

// _錾
D3DVERTEXELEMENT9 decl[] =
{
	{0,  0, D3DDECLTYPE_FLOAT3,   D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0},
	{0, 12, D3DDECLTYPE_FLOAT2,   D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0},
	D3DDECL_END()
};

// Zk`Ă݂
#define RS   m_pd3dDevice->SetRenderState
#define TSS  m_pd3dDevice->SetTextureStageState
#define SAMP m_pd3dDevice->SetSamplerState


//-------------------------------------------------------------
// _̍\
//-------------------------------------------------------------
typedef struct {
    FLOAT       p[4];
    FLOAT       tu, tv;
} TVERTEX;
typedef struct {
    FLOAT       p[4];
    FLOAT       uv1[2];
    FLOAT       uv2[2];
} T2VERTEX;

//-------------------------------------------------------------
// O[oϐ
//-------------------------------------------------------------
CMyD3DApplication* g_pApp  = NULL;
HINSTANCE          g_hInst = NULL;


//-------------------------------------------------------------
// Name: WinMain()
// Desc: C֐
//-------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    CMyD3DApplication d3dApp;

    g_pApp  = &d3dApp;
    g_hInst = hInst;

    InitCommonControls();
    if( FAILED( d3dApp.Create( hInst ) ) )
        return 0;

    return d3dApp.Run();
}




//-------------------------------------------------------------
// Name: CMyD3DApplication()
// Desc: AvP[ṼRXgN^
//-------------------------------------------------------------
CMyD3DApplication::CMyD3DApplication()
{
	m_pMesh						= new CD3DMesh();

	m_pMapZ						= NULL;
	m_pOriginalTex				= NULL;
	m_pOriginalSurf				= NULL;
	m_pLumTex					= NULL;
	m_pLumSurf					= NULL;
	m_pXMap						= NULL;
	m_pXMapSurf					= NULL;
	m_pLargeTex					= NULL;
	m_pLargeSurf				= NULL;
	m_pSmallTex					= NULL;
	m_pSmallSurf				= NULL;

	m_pEffect					= NULL;
	m_hTechnique  				= NULL;
	m_hafWeight					= NULL;
	m_htSrcMap					= NULL;
	m_htSrcMap2					= NULL;
	m_hmWVP						= NULL;
	m_hvLightDir				= NULL;
	m_hvEyePos					= NULL;
	m_hvCol						= NULL;
	m_pDecl						= NULL;

	m_fWorldRotX                = -0.41271535f;
    m_fWorldRotY                = D3DX_PI/2;
	m_fViewZoom				    = 2.0f;

	m_dwCreationWidth           = 512;
    m_dwCreationHeight          = 512;
    m_strWindowTitle            = TEXT( "main" );
    m_d3dEnumeration.AppUsesDepthBuffer   = TRUE;
	m_bStartFullscreen			= false;
	m_bShowCursorWhenFullscreen	= false;

    m_pFont                     = new CD3DFont( _T("Arial"), 12, D3DFONT_BOLD );
    m_bLoadingApp               = TRUE;

    ZeroMemory( &m_UserInput, sizeof(m_UserInput) );
}




//-------------------------------------------------------------
// Name: ~CMyD3DApplication()
// Desc: fXgN^
//-------------------------------------------------------------
CMyD3DApplication::~CMyD3DApplication()
{
}




//-------------------------------------------------------------
// Name: OneTimeSceneInit()
// Desc: xs
//		EBhȄIDirect3D9̏͏IĂ܂B
//		ALPDIRECT3DDEVICE9 ̏͏IĂ܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::OneTimeSceneInit()
{
    // [fBObZ[W\
    SendMessage( m_hWnd, WM_PAINT, 0, 0 );

    m_bLoadingApp = FALSE;

    return S_OK;
}




//-------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: ̎ɌĂ΂܂BKvȔ\͂`FbN܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::ConfirmDevice( D3DCAPS9* pCaps,
                     DWORD dwBehavior,    D3DFORMAT Format )
{
    UNREFERENCED_PARAMETER( Format );
    UNREFERENCED_PARAMETER( dwBehavior );
    UNREFERENCED_PARAMETER( pCaps );
    

	// sNZVF[_o[W`FbN
    if( pCaps->PixelShaderVersion < D3DPS_VERSION(2,0) )
		return E_FAIL;

    // _VF[_o[Wʂ\tgEFA_
    if( pCaps->VertexShaderVersion < D3DVS_VERSION(1,1)
    &&  0==(dwBehavior & D3DCREATE_SOFTWARE_VERTEXPROCESSING) )
			return E_FAIL;

    return S_OK;
}




//-------------------------------------------------------------
// Name: UpdateWeight()
// Desc: ď݂vZ
//-------------------------------------------------------------
VOID CMyD3DApplication::UpdateWeight( )
{
	DWORD i, j;
	FLOAT size[2][3] = {
						//           
						{ 30.0f, 17.5f, 9.8f},// O
						{ 20.0f, 11.2f, 7.5f},// 
					};
	
	for(j=0;j<2;j++){
		FLOAT total[3]={0,0,0};
		for( i=0; i<WEIGHT_MUN; i++ ){
			FLOAT pos = 1.0f+2.0f*(FLOAT)i;
			// KEXd݂vZ
			m_tbl[j][i].x = expf(-0.5f*(FLOAT)(pos*pos)/size[j][0]);
			m_tbl[j][i].y = expf(-0.5f*(FLOAT)(pos*pos)/size[j][1]);
			m_tbl[j][i].z = expf(-0.5f*(FLOAT)(pos*pos)/size[j][2]);
			// Kî߂̏d݂̑avZ
			total[0] += 2.0f*m_tbl[j][i].x;
			total[1] += 2.0f*m_tbl[j][i].y;
			total[2] += 2.0f*m_tbl[j][i].z;

			m_tbl[j][i].w = 1;
		}
		// Ki
		for( i=0; i<WEIGHT_MUN; i++ ){
			m_tbl[j][i].x /= total[0];
			m_tbl[j][i].y /= total[1];
			m_tbl[j][i].z /= total[2];
		}
	}
}




//-------------------------------------------------------------
// Name: InitDeviceObjects()
// Desc: foCXꂽ̏܂B
//		t[obt@tH[}bgfoCX̎ނς
//		ɒʉ߂܂B
//		ŊmۂDeleteDeviceObjects()ŊJ܂
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InitDeviceObjects()
{
    HRESULT hr;
	D3DXVECTOR4 offset;

	// Ԃ̓ǂݍ
	if(FAILED(hr=m_pMesh  ->Create( m_pd3dDevice, _T("ufo.x"))))
        return DXTRACE_ERR( "LoadCar", hr );
        
	// _錾̃IuWFNg̐
	if( FAILED( hr = m_pd3dDevice->CreateVertexDeclaration( decl, &m_pDecl ) ) )
		return DXTRACE_ERR( "CreateVertexDeclaration", hr );
	
	// VF[_̓ǂݍ
	LPD3DXBUFFER pErr;
    if( FAILED( hr = D3DXCreateEffectFromFile(
				m_pd3dDevice, "hlsl.fx", NULL, NULL, 
				D3DXSHADER_DEBUG , NULL, &m_pEffect, &pErr ))){
		MessageBox( NULL, (LPCTSTR)pErr->GetBufferPointer()
					, "ERROR", MB_OK);
		return DXTRACE_ERR( "CreateEffectFromFile", hr );
	}
	m_hTechnique = m_pEffect->GetTechniqueByName( "TShader" );
	m_hafWeight  = m_pEffect->GetParameterByName( NULL, "weight" );
	m_htSrcMap   = m_pEffect->GetParameterByName( NULL, "SrcMap" );
	m_htSrcMap2  = m_pEffect->GetParameterByName( NULL, "SrcMap2" );
	m_hmWVP      = m_pEffect->GetParameterByName( NULL, "mWVP" );
	m_hvLightDir = m_pEffect->GetParameterByName( NULL, "vLightDir" );
	m_hvEyePos   = m_pEffect->GetParameterByName( NULL, "vEyePos" );
	m_hvCol      = m_pEffect->GetParameterByName( NULL, "vCol" );
	m_pEffect->SetFloat("MAP_WIDTH",  MAP_WIDTH);	// ̐ݒ
	m_pEffect->SetFloat("MAP_HEIGHT", MAP_HEIGHT);	// ̐ݒ
	
	// VF[_ŎgWeNZw肷萔
	offset.x = 8.0f/MAP_WIDTH;  offset.y = 0.0f/MAP_HEIGHT;
	m_pEffect->SetVector("offsetX",  &offset);
	offset.x = 0.0f/MAP_WIDTH;	offset.y = 8.0f/MAP_HEIGHT;
	m_pEffect->SetVector("offsetY",  &offset);

	// d݂ݒ
	this->UpdateWeight();

	// tHg
    m_pFont->InitDeviceObjects( m_pd3dDevice );

    return S_OK;
}

//-------------------------------------------------------------
// Name: RestoreDeviceObjects()
// Desc: ʂ̃TCYύXꂽɌĂ΂܂B
//		mۂInvalidateDeviceObjects()ŊJ܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RestoreDeviceObjects()
{
	// bV
	m_pMesh  ->RestoreDeviceObjects( m_pd3dDevice );

    // _OԂ̐ݒ
    RS( D3DRS_DITHERENABLE,   FALSE );
    RS( D3DRS_SPECULARENABLE, FALSE );
    RS( D3DRS_ZENABLE,        TRUE );
    
    TSS( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    TSS( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    TSS( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
    TSS( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
    TSS( 0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE );
    SAMP( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
    SAMP( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
    SAMP( 0, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP );
    SAMP( 0, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP );

    // [hs
    D3DXMATRIX matIdentity;
    D3DXMatrixIdentity( &m_mWorld );

	// r[s
    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -5.0f );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &m_mView, &vFromPt, &vLookatPt, &vUpVec );

    // ˉes
    FLOAT fAspect = ((FLOAT)m_d3dsdBackBuffer.Width) / m_d3dsdBackBuffer.Height;
    D3DXMatrixPerspectiveFovLH( &m_mProj, D3DX_PI/4, fAspect, 1.0f, 100.0f );

    // tHg
    m_pFont->RestoreDeviceObjects();

	// _O^[Qbg̐
	if (FAILED(m_pd3dDevice->CreateDepthStencilSurface(RENDERING_WIDTH, RENDERING_HEIGHT, 
		D3DFMT_D16, D3DMULTISAMPLE_NONE, 0, TRUE, &m_pMapZ, NULL)))
		return E_FAIL;
	if (FAILED(m_pd3dDevice->CreateTexture(RENDERING_WIDTH, RENDERING_HEIGHT, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pOriginalTex, NULL)))
		return E_FAIL;
	// kobt@
	if (FAILED(m_pOriginalTex->GetSurfaceLevel(0, &m_pOriginalSurf)))
		return E_FAIL;
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_WIDTH, MAP_HEIGHT, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pLumTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pLumTex->GetSurfaceLevel(0, &m_pLumSurf)))
		return E_FAIL;
	// X̂ڂ
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_WIDTH, MAP_HEIGHT, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pXMap, NULL)))
		return E_FAIL;
	if (FAILED(m_pXMap->GetSurfaceLevel(0, &m_pXMapSurf)))
		return E_FAIL;
	// 傫ڂ̉~
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_WIDTH, MAP_HEIGHT, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pLargeTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pLargeTex->GetSurfaceLevel(0, &m_pLargeSurf)))
		return E_FAIL;
	// ڂ̉~
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_WIDTH, MAP_HEIGHT, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pSmallTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pSmallTex->GetSurfaceLevel(0, &m_pSmallSurf)))
		return E_FAIL;

	m_pEffect->OnResetDevice();

	return S_OK;
}




//-------------------------------------------------------------
// Name: FrameMove()
// Desc: t[Ă΂܂BAj̏Ȃǂs܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FrameMove()
{
    // ̓f[^̍XV
    UpdateInput( &m_UserInput );

	//---------------------------------------------------------
	// ͂ɉčWnXV
	//---------------------------------------------------------
	// ]
    D3DXMATRIX matRotY;
    D3DXMATRIX matRotX;

    if( m_UserInput.bRotateLeft && !m_UserInput.bRotateRight )
        m_fWorldRotY += m_fElapsedTime;
    else
    if( m_UserInput.bRotateRight && !m_UserInput.bRotateLeft )
        m_fWorldRotY -= m_fElapsedTime;

    if( m_UserInput.bRotateUp && !m_UserInput.bRotateDown )
        m_fWorldRotX += m_fElapsedTime;
    else
    if( m_UserInput.bRotateDown && !m_UserInput.bRotateUp )
        m_fWorldRotX -= m_fElapsedTime;

    D3DXMatrixRotationX( &matRotX, m_fWorldRotX );
    D3DXMatrixRotationY( &matRotY, m_fWorldRotY );

    D3DXMatrixMultiply( &m_mWorld, &matRotY, &matRotX );
	
	//---------------------------------------------------------
	// r[s̐ݒ
	//---------------------------------------------------------
	// Y[
    if( m_UserInput.bZoomIn && !m_UserInput.bZoomOut )
        m_fViewZoom += m_fElapsedTime;
    else if( m_UserInput.bZoomOut && !m_UserInput.bZoomIn )
        m_fViewZoom -= m_fElapsedTime;

    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -m_fViewZoom );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &m_mView, &vFromPt, &vLookatPt, &vUpVec );

	return S_OK;
}
//-------------------------------------------------------------
// Name: UpdateInput()
// Desc: ̓f[^XV
//-------------------------------------------------------------
void CMyD3DApplication::UpdateInput( UserInput* pUserInput )
{
    pUserInput->bRotateUp    = ( m_bActive && (GetAsyncKeyState( VK_UP )    & 0x8000) == 0x8000 );
    pUserInput->bRotateDown  = ( m_bActive && (GetAsyncKeyState( VK_DOWN )  & 0x8000) == 0x8000 );
    pUserInput->bRotateLeft  = ( m_bActive && (GetAsyncKeyState( VK_LEFT )  & 0x8000) == 0x8000 );
    pUserInput->bRotateRight = ( m_bActive && (GetAsyncKeyState( VK_RIGHT ) & 0x8000) == 0x8000 );
    
	pUserInput->bZoomIn      = ( m_bActive && (GetAsyncKeyState( 'Z'     )  & 0x8000) == 0x8000 );
    pUserInput->bZoomOut     = ( m_bActive && (GetAsyncKeyState( 'X'      ) & 0x8000) == 0x8000 );
}


//-------------------------------------------------------------
// Name: Render()
// Desc: ʂ`悷.
//-------------------------------------------------------------
HRESULT CMyD3DApplication::Render()
{
    D3DXMATRIX m, mL, mR, mView, mProj;
	LPDIRECT3DSURFACE9 pOldBackBuffer, pOldZBuffer;
	D3DVIEWPORT9 oldViewport;
	D3DXVECTOR4 v, light_pos;
	D3DMATERIAL9 *pMtrl;
	DWORD i;

	//---------------------------------------------------------
	// `
	//---------------------------------------------------------
    if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
    {
		//-------------------------------------------------
		// _O^[Qbg̕ۑ
		//-------------------------------------------------
		m_pd3dDevice->GetRenderTarget(0, &pOldBackBuffer);
		m_pd3dDevice->GetDepthStencilSurface(&pOldZBuffer);
		m_pd3dDevice->GetViewport(&oldViewport);

		if( m_pEffect != NULL ) 
		{
			//-------------------------------------------------
			// _O^[Qbg̕ύX
			//-------------------------------------------------
			m_pd3dDevice->SetRenderTarget(0, m_pOriginalSurf);
			m_pd3dDevice->SetDepthStencilSurface(m_pMapZ);
			// r[|[g̕ύX
			D3DVIEWPORT9 viewport = {0,0      // ̍W
							, RENDERING_WIDTH  // 
							, RENDERING_HEIGHT // 
							, 0.0f,1.0f};     // OʁA
			m_pd3dDevice->SetViewport(&viewport);

			// _O^[Qbg̃NA
			m_pd3dDevice->Clear(0L, NULL
							, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER
							, 0x000000, 1.0f, 0L);

			//-------------------------------------------------
			// V[̕`
			//-------------------------------------------------
			TSS( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
			TSS( 0, D3DTSS_COLORARG1, D3DTA_DIFFUSE );

			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( PASS_SCENE );

			// ړ
			D3DXMatrixTranslation( &m, 0.5f, 0.0f ,0.0f );
			D3DXMatrixRotationY( &mR,  m_fTime );
			mL = m * mR * m_mWorld;
			// Cg̕
			D3DXMatrixInverse( &m, NULL, &mL);
			light_pos = D3DXVECTOR4(1,1,-1,0);
			D3DXVec4Transform( &v, &light_pos, &m );
			v.w = 0;
			D3DXVec4Normalize( &v, &v );
			m_pEffect->SetVector( m_hvLightDir, &v );
			// _
			D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -m_fViewZoom );
			D3DXVec3Transform( &v, &vFromPt, &m );
			m_pEffect->SetVector( m_hvEyePos, &v );
			// [J-ˉeϊs
			m = mL * m_mView * m_mProj;
			m_pEffect->SetMatrix( m_hmWVP, &m );

			pMtrl = m_pMesh->m_pMaterials;
			for( i=0; i<m_pMesh->m_dwNumMaterials; i++ ) {
				v.x = pMtrl->Diffuse.r;
				v.y = pMtrl->Diffuse.g;
				v.z = pMtrl->Diffuse.b;
				v.w = pMtrl->Diffuse.a;
				m_pEffect->SetVector( m_hvCol, &v );
				m_pMesh->m_pLocalMesh->DrawSubset( i );  // `
				pMtrl++;
			}

			m_pEffect->End();

			//-------------------------------------------------
			// k}bv̍쐬
			//-------------------------------------------------
			m_pd3dDevice->SetRenderTarget(0, m_pLumSurf);
			D3DVIEWPORT9 viewport_map = {0,0      // ̍W
						, MAP_WIDTH  // 
						, MAP_HEIGHT // 
						, 0.0f,1.0f};     // OʁA
			m_pd3dDevice->SetViewport(&viewport_map);

			RS( D3DRS_ZENABLE, FALSE );
			RS( D3DRS_LIGHTING, FALSE );
			TSS(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
			TSS(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
			TSS(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);

			FLOAT w = (FLOAT)MAP_WIDTH;
			FLOAT h = (FLOAT)MAP_HEIGHT;
			FLOAT du = 0.5f/RENDERING_WIDTH;
			FLOAT dv = 0.5f/RENDERING_HEIGHT;
			TVERTEX Vertex0[4] = {
				//x  y   z    rhw    tu    tv
				{ 0, 0, 0.1f, 1.0f, 0+du, 0+dv,},
				{ w, 0, 0.1f, 1.0f, 1+du, 0+dv,},
				{ w, h, 0.1f, 1.0f, 1+du, 1+dv,},
				{ 0, h, 0.1f, 1.0f, 0+du, 1+dv,},
			};
			m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
			m_pd3dDevice->SetTexture(0, m_pOriginalTex);

			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( PASS_REDUCTION );
			m_pEffect->SetTexture(m_htSrcMap, m_pOriginalTex);

			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
								, 2, Vertex0, sizeof( TVERTEX ) );

			m_pEffect->End();

			//-------------------------------------------------
			// VF[_̐ݒ
			//-------------------------------------------------
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );

			//-------------------------------------------------
			// 傫Ȃڂx
			//-------------------------------------------------
			typedef struct {FLOAT p[3];FLOAT tu, tv;} VERTEX;
			VERTEX Vertex1[4] = {
				//   x      y     z      tu tv
				{{  1.0f, -1.0f, 0.1f},   1, 1,},
				{{ -1.0f, -1.0f, 0.1f},   0, 1,},
				{{ -1.0f,  1.0f, 0.1f},   0, 0,},
				{{  1.0f,  1.0f, 0.1f},   1, 0,},
			};
			m_pd3dDevice->SetRenderTarget(0, m_pXMapSurf);
			m_pEffect->Pass( PASS_X );
			m_pEffect->SetVectorArray(m_hafWeight
									, m_tbl[0], WEIGHT_MUN);

			m_pd3dDevice->SetVertexDeclaration( m_pDecl );
			m_pEffect->SetTexture(m_htSrcMap, m_pLumTex);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( VERTEX ) );

			//-------------------------------------------------
			// 傫Ȃڂy
			//-------------------------------------------------
			m_pd3dDevice->SetRenderTarget(0, m_pLargeSurf);
			m_pEffect->Pass( PASS_Y );

			m_pEffect->SetTexture(m_htSrcMap, m_pXMap);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( VERTEX ) );

			//-------------------------------------------------
			// Ȃڂx
			//-------------------------------------------------
			m_pd3dDevice->SetRenderTarget(0, m_pXMapSurf);
			m_pEffect->Pass( PASS_X );
			m_pEffect->SetVectorArray(m_hafWeight
									, m_tbl[1], WEIGHT_MUN);

			m_pEffect->SetTexture(m_htSrcMap, m_pLumTex);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( VERTEX ) );

			//-------------------------------------------------
			// Ȃڂy
			//-------------------------------------------------
			m_pd3dDevice->SetRenderTarget(0, m_pSmallSurf);
			m_pEffect->Pass( PASS_Y );

			m_pEffect->SetTexture(m_htSrcMap, m_pXMap);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( VERTEX ) );

			m_pEffect->End();
		}

		//-----------------------------------------------------
		// _O^[Qbgɖ߂
		//-----------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, pOldBackBuffer);
		m_pd3dDevice->SetDepthStencilSurface(pOldZBuffer);
		m_pd3dDevice->SetViewport(&oldViewport);
		pOldBackBuffer->Release();
		pOldZBuffer->Release();

		// obt@̃NA
		m_pd3dDevice->Clear( 0L, NULL
						, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER
						, 0x00404080, 1.0f, 0L );

		//-----------------------------------------------------
		// ̂܂ܒ
		//-----------------------------------------------------
		FLOAT w = (FLOAT)oldViewport.Width;
		FLOAT h = (FLOAT)oldViewport.Height;
		TVERTEX Vertex1[4] = {
			//x  y   z    rhw  tu tv
			{ 0, 0, 0.1f, 1.0f, 0+0.5f/RENDERING_WIDTH, 0+0.5f/RENDERING_HEIGHT,},
			{ w, 0, 0.1f, 1.0f, 1+0.5f/RENDERING_WIDTH, 0+0.5f/RENDERING_HEIGHT,},
			{ w, h, 0.1f, 1.0f, 1+0.5f/RENDERING_WIDTH, 1+0.5f/RENDERING_HEIGHT,},
			{ 0, h, 0.1f, 1.0f, 0+0.5f/RENDERING_WIDTH, 1+0.5f/RENDERING_HEIGHT,},
		};
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		m_pd3dDevice->SetTexture(0, m_pOriginalTex);
		m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( TVERTEX ) );
		
		//-----------------------------------------------------
		// ŏIIɍ
		//-----------------------------------------------------
		if(m_pEffect){
			FLOAT du = 1.5f/MAP_WIDTH;
			FLOAT dv = 1.5f/MAP_HEIGHT;
			T2VERTEX Vertex2[4] = {
				//   x    y   z    rhw     tu1      tv1      tu2      tv2
				{ 0.0f,   0, 0.1f, 1.0f, 0.0f+du, 0.0f+dv, 0.0f+du, 0.0f+dv,},
				{ 1.0f*w, 0, 0.1f, 1.0f, 1.0f+du, 0.0f+dv, 1.0f+du, 0.0f+dv,},
				{ 1.0f*w, h, 0.1f, 1.0f, 1.0f+du, 1.0f+dv, 1.0f+du, 1.0f+dv,},
				{ 0.0f,   h, 0.1f, 1.0f, 0.0f+du, 1.0f+dv, 0.0f+du, 1.0f+dv,},
			};
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( PASS_FINAL );

			RS(D3DRS_ALPHABLENDENABLE, TRUE);
			RS(D3DRS_SRCBLEND , D3DBLEND_ONE);
			RS(D3DRS_DESTBLEND , D3DBLEND_ONE);
			m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX2 );
			m_pEffect->SetTexture(m_htSrcMap,  m_pLargeTex);
			m_pEffect->SetTexture(m_htSrcMap2, m_pSmallTex);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
								, 2, Vertex2, sizeof( T2VERTEX ) );
			m_pEffect->End();
		}

		RS( D3DRS_ZENABLE, TRUE );
		RS( D3DRS_LIGHTING, TRUE );
		RS(D3DRS_ALPHABLENDENABLE, FALSE );

        // wv̕\
        RenderText();

#if 1 // fobOpɃeNX`\
		{
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetVertexShader(NULL);
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		m_pd3dDevice->SetPixelShader(0);
		float scale = 100.0f;
		for(DWORD i=0; i<5; i++){
			TVERTEX Vertex[4] = {
				// x  y  z rhw tu tv
				{(i+0)*scale,    0,0, 1, 0, 0,},
				{(i+1)*scale,    0,0, 1, 1, 0,},
				{(i+1)*scale,scale,0, 1, 1, 1,},
				{(i+0)*scale,scale,0, 1, 0, 1,},
			};
			if(0==i) m_pd3dDevice->SetTexture( 0, m_pOriginalTex );
			if(1==i) m_pd3dDevice->SetTexture( 0, m_pLumTex );
			if(2==i) m_pd3dDevice->SetTexture( 0, m_pXMap );
			if(3==i) m_pd3dDevice->SetTexture( 0, m_pLargeTex );
			if(4==i) m_pd3dDevice->SetTexture( 0, m_pSmallTex );
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
		}
		}
#endif		

		// `̏I
        m_pd3dDevice->EndScene();
    }

    return S_OK;
}




//-------------------------------------------------------------
// Name: RenderText()
// Desc: Ԃwvʂɕ\
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RenderText()
{
    D3DCOLOR fontColor        = D3DCOLOR_ARGB(255,255,255,0);
    TCHAR szMsg[MAX_PATH] = TEXT("");

    FLOAT fNextLine = 40.0f; // \鍂

    // @p[^\
    fNextLine = (FLOAT) m_d3dsdBackBuffer.Height; 
    lstrcpy( szMsg, TEXT("Press 'F2' to configure display") );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );

    lstrcpy( szMsg, m_strDeviceStats );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
    lstrcpy( szMsg, m_strFrameStats );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
	
	return S_OK;
}




//-------------------------------------------------------------
// Name: MsgProc()
// Desc: WndProc I[o[Ch
//-------------------------------------------------------------
LRESULT CMyD3DApplication::MsgProc( HWND hWnd, UINT msg,
                                 WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_PAINT:
        {
            if( m_bLoadingApp )
            {
                // [h
                HDC hDC = GetDC( hWnd );
                TCHAR strMsg[MAX_PATH];
                wsprintf(strMsg, TEXT("Loading... Please wait"));
                RECT rct;
                GetClientRect( hWnd, &rct );
                DrawText( hDC, strMsg, -1, &rct
                		, DT_CENTER|DT_VCENTER|DT_SINGLELINE );
                ReleaseDC( hWnd, hDC );
            }
            break;
        }

    }

    return CD3DApplication::MsgProc( hWnd, msg, wParam, lParam );
}




//-------------------------------------------------------------
// Name: InvalidateDeviceObjects()
// Desc: RestoreDeviceObjects() ō쐬IuWFNg̊J
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InvalidateDeviceObjects()
{
	// VhE}bv
	SAFE_RELEASE(m_pLargeSurf);
	SAFE_RELEASE(m_pLargeTex);
	SAFE_RELEASE(m_pSmallSurf);
	SAFE_RELEASE(m_pSmallTex);
	SAFE_RELEASE(m_pXMapSurf);
	SAFE_RELEASE(m_pXMap);
	SAFE_RELEASE(m_pLumSurf);
	SAFE_RELEASE(m_pLumTex);
	SAFE_RELEASE(m_pOriginalSurf);
	SAFE_RELEASE(m_pOriginalTex);
	SAFE_RELEASE(m_pMapZ);

	m_pMesh  ->InvalidateDeviceObjects(); // bV

    m_pFont->InvalidateDeviceObjects();	// tHg

	// VF[_
    if( m_pEffect != NULL ) m_pEffect->OnLostDevice();

    return S_OK;
}




//-------------------------------------------------------------
// Name: DeleteDeviceObjects()
// Desc: InitDeviceObjects() ō쐬IuWFNgJ
//-------------------------------------------------------------
HRESULT CMyD3DApplication::DeleteDeviceObjects()
{
    // VF[_
	SAFE_RELEASE( m_pEffect );
	SAFE_RELEASE( m_pDecl );
	
	// bV
	m_pMesh  ->Destroy();

    // tHg
    m_pFont->DeleteDeviceObjects();

    return S_OK;
}




//-------------------------------------------------------------
// Name: FinalCleanup()
// Desc: I钼ɌĂ΂
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FinalCleanup()
{
	SAFE_DELETE( m_pMesh );

    SAFE_DELETE( m_pFont );	// tHg

    return S_OK;
}




